﻿using System;
using System.IO;
using System.Security;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SGLC;

namespace Demo1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            pcie6603.LC_Close();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int rc = 0;
            rc = pcie6603.LC_Open();
            if (rc != 0)
            {
                MessageBox.Show("open fails(" + rc.ToString() + ")");
                Application.Exit();
            }
            else
            {
                timer1.Enabled = true;                
            }

            NcConfig.Load();
            uint[] buf = new uint[32];
            rc = pcie6603.LC_GetDevInfo(0, buf, Convert.ToUInt32(buf.Length));
            if (rc == 0)
            {
                NcConfig.fpgaVer[0] = buf[4];
                if (buf[4] >= 0x0102)
                {
                    NcConfig.fpgaIs0102[0] = true;

                    lblDoutStatus.Enabled = true;
                    lblMirrorPos.Enabled = true;
                    chkEnableMirrorPos.Enabled = true;
                }
                else
                {
                    lblDoutStatus.Enabled = false;
                    lblMirrorPos.Enabled = false;
                    chkEnableMirrorPos.Checked = false;
                    chkEnableMirrorPos.Enabled = false;
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            uint[] stat = new uint[32];
            int rc = 0;
            //string str;
            rc = pcie6603.LC_GetStatus(0, stat, 16);
            if (rc == 0)
            {
                stat[0] = stat[0] & 0x3fffff;   //mask unused bits
                lblDin.Text = "Din: " + stat[0].ToString("x8");
                lblDout.Text = "Dout: " + stat[1].ToString("x8");
                lblXY2Status.Text = "XY2 Status: " + stat[2].ToString("x");
                lblFifoError.Text = "Fifo Error: " + ((stat[3] == 0) ? "N" : "Y");
                lblPLLError.Text = "PLL Error: " + ((stat[4] == 0) ? "N" : "Y");
                lblFifoSize.Text = "Fifo Size: " + stat[5].ToString() + " bytes";
                lblFifoItemSize.Text = "Fifo Item Size: " + stat[6].ToString() + " bytes";

                lblFifoLen.Text = "Fifo Len: " + stat[9].ToString();
                lblFifoFull.Text = "Fifo Full: " + ((stat[10] == 0) ? "N" : "Y");
                lblStsMinPeriod.Text = "Min Period: " + stat[11].ToString() + " ns";
                lblStsMaxPeriod.Text = "Max Period: " + stat[12].ToString() + " ns";
                lblStsMeanPeriod.Text = "Mean Period: " + stat[13].ToString() + " ns";

                //str = "";
                //for (i = 0; i < 18; i++)
                //{
                //    str = str + "[" + i.ToString() + "]: " + stat[i].ToString("x") + "\r\n";
                //}
                //txtMsg.Text = str;
            }

            if (chkEnableMirrorPos.Checked)
            {
                //
                //读取振镜的位置、数字输出的状态（严格来讲，要等到队列指令发送完毕、硬件FIFO数据发送完毕后才是真实的状态）
                //
                //寄存器0x1080, bit[31:16] #1振镜位置；bit[15:0] #0振镜位置；
                //寄存器0x1084, bit[15:0] #2振镜位置；
                //寄存器0x108c, bit[27:0] 数字输出的状态
                //
                //寄存器0x1098， bit[0] 硬件FIFO的空标记，1表示硬件FIFO为空
                //
                uint pos = 0, pos2 = 0, d = 0;
                pcie6603.LC_Ind(0, 0x1080, ref pos);
                pcie6603.LC_Ind(0, 0x1084, ref pos2);
                pcie6603.LC_Ind(0, 0x108c, ref d);

                lblMirrorPos.Text = String.Format("Mirror Pos: {0}, {1}, {2}", (pos & 0xffff).ToString("x4"), ((pos >> 16)& 0xffff).ToString("x4"), (pos2 & 0xffff).ToString("x4"));
                lblDoutStatus.Text = String.Format("Dout: {0}", d.ToString("x8"));
            }
        }
        /// <summary>
        ///  XY2-100设置位置测试
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTest_Click(object sender, EventArgs e)
        {
            int index, length, step, rc;
            uint[] buffer = new uint[0x100000];
            uint actcnt = 0;

            //画方框， (0,0)-(length, 0)-(length, length)-(0,0)
            length = 15000;
            step = 1;
            index = 0;
            for (int i = 0; i <= length; i+= step)
            {
                buffer[index++] = pcie6603.XY2_CMD_POS_X(i);
                buffer[index++] = pcie6603.XY2_CMD_POS_Y(0);
                buffer[index++] = pcie6603.XY2_CMD_DELAY(1u);  //10us
            }

            for (int i = 0; i <= length; i += step)
            {
                buffer[index++] = pcie6603.XY2_CMD_POS_X(length);
                buffer[index++] = pcie6603.XY2_CMD_POS_Y(i);
                buffer[index++] = pcie6603.XY2_CMD_DELAY(1u);  //10us
            }

            for (int i = 0; i <= length; i += step)
            {
                buffer[index++] = pcie6603.XY2_CMD_POS_X(length-i);
                buffer[index++] = pcie6603.XY2_CMD_POS_Y(length);
                buffer[index++] = pcie6603.XY2_CMD_DELAY(1u);  //10us
            }

            for (int i = 0; i <= length; i += step)
            {
                buffer[index++] = pcie6603.XY2_CMD_POS_X(0);
                buffer[index++] = pcie6603.XY2_CMD_POS_Y(length - i);
                buffer[index++] = pcie6603.XY2_CMD_DELAY(1u);  //10us
            }

            actcnt = 0;
            rc = pcie6603.LC_SubmitBuffer(0, buffer, Convert.ToUInt32(index), ref actcnt);
            if (rc != 0)
            {
                MessageBox.Show("LC_SubmitBuffer fails(" + rc.ToString() + ")");
            }
            else
            {
                if (actcnt != index)
                {
                    MessageBox.Show("length check fails(" + actcnt.ToString() + ", expect: " + index.ToString() + ")");
                }

                //MessageBox.Show("LC_SubmitBuffer(" + index.ToString() + " commands)");
            }
        }
        /// <summary>
        /// 反转数字量输出测试
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnToggleDout_Click(object sender, EventArgs e)
        {
            int index,rc, k;
            uint[] buffer = new uint[0x100000];
            uint actcnt = 0, cnt;
            uint dout = 0, length;

            //在DO[20]上模拟1KHZ PWM输出， DO[20]为反相输出
            //dout = 0;
            //length = 0x4000;    //~20seconds
            //index = 0;
            //for (uint i = 0; i < length; i += 1u)
            //{
            //    offset = i % 128;
            //    dout = dout | (1u << 20);
            //    dout = dout & ~(1u << 21);
            //    buffer[index++] = pcie6603.XY2_CMD_DOUT(dout);
            //    buffer[index++] = pcie6603.XY2_CMD_DELAY(offset);  //10us

            //    dout = dout & ~(1u << 20);
            //    dout = dout | (1u << 21);
            //    buffer[index++] = pcie6603.XY2_CMD_DOUT(dout);
            //    buffer[index++] = pcie6603.XY2_CMD_DELAY(128 - offset);  //10us
            //}

            //toggle AP/dout[10]
            //Ouput high for 30ms ,then low for 20ms, and then delay for 1 seconds
            //loop for 100 times
            dout = 0;
            length = 100; 
            index = 0;
            for (uint i = 0; i < length; i += 1u)
            {
                for (k = 0; k < 4; k++)
                {
                    buffer[index++] = pcie6603.XY2_CMD_POS_X(0x8000 + k*0x1000);
                    buffer[index++] = pcie6603.XY2_CMD_POS_Y(0x8000);

                    dout = dout | (1u << 10);
                    buffer[index++] = pcie6603.XY2_CMD_DOUT(dout);
                    buffer[index++] = pcie6603.XY2_CMD_DELAY(10000u);  //30ms
                    dout = dout & ~(1u << 10);
                    buffer[index++] = pcie6603.XY2_CMD_DOUT(dout);
                    buffer[index++] = pcie6603.XY2_CMD_DELAY(10000u);  //20ms
                }

                buffer[index++] = pcie6603.XY2_CMD_DELAY(100000u);  //1s
            }

            //send once
            actcnt = 0;
            cnt = Convert.ToUInt32(index);
            rc = pcie6603.LC_SubmitBuffer(0, buffer, cnt, ref actcnt);
            if (rc != 0)
            {
                MessageBox.Show("LC_SubmitBuffer[1] fails(" + rc.ToString() + ")");
            }
            else
            {
                if (actcnt != cnt)
                {
                    MessageBox.Show("length check fails(" + actcnt.ToString() + ", expect: " + cnt.ToString() + ")");
                }
            }

            ////send twice
            //actcnt = 0;
            //cnt = Convert.ToUInt32(index);
            //rc = pcie6603.LC_SubmitBuffer(0, buffer, cnt, ref actcnt);
            //if (rc != 0)
            //{
            //    MessageBox.Show("LC_SubmitBuffer[2] fails(" + rc.ToString() + ")");
            //}
            //else
            //{
            //    if (actcnt != cnt)
            //    {
            //        MessageBox.Show("length check fails(" + actcnt.ToString() + ", expect: " + cnt.ToString() + ")");
            //    }
            //}
        }

        private void btnAbort_Click(object sender, EventArgs e)
        {
            int rc = 0;
            rc = pcie6603.LC_Abort(0);
            if (rc != 0)
            {
                MessageBox.Show("LC_SubmitBuffer[2] fails(" + rc.ToString() + ")");
            }
        }
        /// <summary>
        /// 发送数据文件到控制器
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSendFile_Click(object sender, EventArgs e)
        {
            uint itemSize = 0;
            uint actcnt = 0;
            uint[] stat = new uint[32];
            int rc = 0, i;
            OpenFileDialog dlg = new OpenFileDialog();

            rc = pcie6603.LC_GetStatus(0, stat, 16);
            if (rc != 0)
            {
                MessageBox.Show("查询控制器状态失败！");
                return;
            }
            else
            {
                itemSize = stat[6];
                if (itemSize == 0)
                {
                    MessageBox.Show("控制器队列满！");
                    return;
                }
            }

            //打开文件,校验无误后发送
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                //lblFileName.Text = System.IO.Path.GetFileName(dlg.FileName);
                //Properties.Settings.Default.ncfilename = dlg.FileName;      //保存文件名字到xml配置
                //Properties.Settings.Default.Save();
                try
                {
                     // Create the reader for data.
                    FileStream fs = new FileStream(dlg.FileName, FileMode.Open, FileAccess.Read);
                    BinaryReader r = new BinaryReader(fs);

                    if (fs.Length % 4 != 0)
                    {
                        MessageBox.Show("文件长度不是指令的整倍数！", "错误");
                        return;
                    }
                    if (fs.Length > itemSize * 4)
                    {
                        MessageBox.Show("文件长度大于可用指令队列大小（" + itemSize.ToString() + " bytes)！", "错误");
                        return;
                    }
                    uint[] buffer = new uint[fs.Length/4];
                    //byte[] data = r.ReadBytes((int)fs.Length);
                    for (i = 0; i < fs.Length / 4; i++)
                    {
                        buffer[i] = r.ReadUInt32();
                    }
                    r.Close();
                    fs.Close();

                    //检查命令是否合法
                    uint cmd = 0;
                    for (i = 0; i < buffer.Length; i++)
                    {
                        cmd = buffer[i] >> 28;
                        if(cmd < 4u || cmd > 0xc)
                        {
                            MessageBox.Show("指令码不正确！", "错误");
                         return;
                        }
                    }

                    rc = pcie6603.LC_SubmitBuffer(0, buffer, Convert.ToUInt32(buffer.Length), ref actcnt);
                    if (rc != 0)
                    {
                    }
                    else
                    {
                        if (actcnt != buffer.Length)
                        {
                            MessageBox.Show("length check fails(" + actcnt.ToString() + ", expect: " + buffer.Length.ToString() + ")");
                        }
                    }
                }
                catch (SecurityException ex)
                {
                    MessageBox.Show("访问文件异常！", "错误");
                }
            }
        }

        /// <summary>
        /// 显示参数设置窗口
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetParam_Click(object sender, EventArgs e)
        {
            FormParam dlg = new FormParam();
            dlg.Show();
        }

        /// <summary>
        /// 手动操作窗口
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnManual_Click(object sender, EventArgs e)
        {
            FormManual dlg = new FormManual();
            dlg.Show();
        }

        /// <summary>
        /// 判断标刻是否彻底完成（驱动管理的换取区和硬件队列的数据全部发送完毕）
        /// </summary>
        /// <param name="dev">设备号，默认为0</param>
        /// <param name="done">标刻状态，0表示未完成，非零表示完成</param>
        /// <returns>返回0表示执行成功，返回非零表示执行失败</returns>
        public static int MarkIsDone(int dev, ref int done)
        {
            uint[] stat = new uint[32];
            uint d = 0;
            int rc = 0;

            //在缓冲区数据发送完毕并且硬件队列(FIFO)为空时，标刻才真正完成
            done = 0;
            rc = pcie6603.LC_GetStatus(0, stat, 16);
            if (rc == 0)
            {
                 //指令 队列 内 已 存 的 指令块 数目 范围 为 0 ~4 0 表示 队列 为 空 4 表示 队列 满；
                if (stat[9] != 0)
                {
                    return 0;
                }
                else
                {
                    //寄存器0x1098的bit[0]为硬件读列的空标记
                    rc = pcie6603.LC_Ind(dev, 0x1098, ref d);
                    if (rc == 0)
                    {
                        if ((d & 1u) != 0)
                        {
                            done = 1;
                            return 0;
                        }
                    }
                }
            }
            return rc;
        }
    }
}
